// ImageProcessingDoc.cpp : implementation of the CImageProcessingDoc class
//

#include "stdafx.h"
#include "ImageProcessing.h"

#include "ImageProcessingDoc.h"
#include "DownSampleDlg.h"
#include "UpSampleDlg.h"
#include "QuantizationDlg.h"
#include "math.h"
#include "ConstantDlg.h" //  Է ȭ    
#include "StressTransformDlg.h" //     

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CImageProcessingDoc

IMPLEMENT_DYNCREATE(CImageProcessingDoc, CDocument)

BEGIN_MESSAGE_MAP(CImageProcessingDoc, CDocument)
	//{{AFX_MSG_MAP(CImageProcessingDoc)
		// NOTE - the ClassWizard will add and remove mapping macros here.
		//    DO NOT EDIT what you see in these blocks of generated code!
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CImageProcessingDoc construction/destruction

CImageProcessingDoc::CImageProcessingDoc()
{
	// TODO: add one-time construction code here

}

CImageProcessingDoc::~CImageProcessingDoc()
{
}

BOOL CImageProcessingDoc::OnNewDocument()
{
	if (!CDocument::OnNewDocument())
		return FALSE;

	// TODO: add reinitialization code here
	// (SDI documents will reuse this document)

	return TRUE;
}



/////////////////////////////////////////////////////////////////////////////
// CImageProcessingDoc serialization

void CImageProcessingDoc::Serialize(CArchive& ar)
{
	if (ar.IsStoring())
	{
		// TODO: add storing code here
	}
	else
	{
		// TODO: add loading code here
	}
}

/////////////////////////////////////////////////////////////////////////////
// CImageProcessingDoc diagnostics

#ifdef _DEBUG
void CImageProcessingDoc::AssertValid() const
{
	CDocument::AssertValid();
}

void CImageProcessingDoc::Dump(CDumpContext& dc) const
{
	CDocument::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CImageProcessingDoc commands


BOOL CImageProcessingDoc::OnOpenDocument(LPCTSTR lpszPathName) 
{
	if (!CDocument::OnOpenDocument(lpszPathName))
		return FALSE;
	
	CFile File;

	File.Open(lpszPathName, CFile::modeRead | CFile::typeBinary);

	if(File.GetLength() == 32*32){ // RAW  ũ 
			m_height = 32;
			m_width = 32;
		}
		else if(File.GetLength() == 64*64){ // RAW  ũ 
			m_height = 64;
			m_width = 64;
		}
		else if(File.GetLength() == 128*128){ // RAW  ũ 
			m_height = 128;
			m_width = 128;
		}
		else if(File.GetLength() == 256*256){ // RAW  ũ 
			m_height = 256;
			m_width = 256;
		}
		else if(File.GetLength() == 512*512){ // RAW  ũ 
			m_height = 512;
			m_width = 512;		
		}
		else if(File.GetLength() == 640*480){ // RAW  ũ 
			m_height = 480;
			m_width = 640;
		}
		else if(File.GetLength() == 176*144){// RAW  ũ 
			m_height = 144;
			m_width = 176;
		}
		else if(File.GetLength() == 288*384){ // RAW  ũ 
			m_height = 288;
			m_width = 384;
		}
		else{
			AfxMessageBox("Not Support Image Size"); //32*32, 64*64, 128*128, 256*256, 512*512, 640*480, 176*144 ũ ϸ 
			return 0;									 // Ÿ ̹ ũ ϶ 
		}

	m_size = m_width * m_height;

	m_InputImage = new unsigned char [m_size]; 
		
	for(int i = 0 ; i<m_size ; i++)
		m_InputImage[i] = 255;
		
	File.Read(m_InputImage, m_size); //  б 
	File.Close();
	
	return TRUE;
}

BOOL CImageProcessingDoc::OnSaveDocument(LPCTSTR lpszPathName) 
{
	CFile File;
	CFileDialog SaveDlg(FALSE, "raw", NULL, OFN_HIDEREADONLY);

	if(SaveDlg.DoModal() == IDOK){
		File.Open(SaveDlg.GetPathName(), CFile::modeCreate | CFile::modeWrite);
		File.Write(m_OutputImage, m_Re_size);
		File.Close();
	}
	
	return TRUE; 
}

void CImageProcessingDoc::OnDownSampling()
{
	int i, j;

	CDownSampleDlg dlg;
	
	if(dlg.DoModal() == IDOK)
	{
		m_Re_height = m_height / dlg.m_DownSampleRate;
		m_Re_width = m_width / dlg.m_DownSampleRate;
		m_Re_size = m_Re_height * m_Re_width;

		m_OutputImage = new unsigned char [m_Re_size];

		for(i=0 ; i<m_Re_size ; i++)
			m_OutputImage[i] = 255;

		for(i=0 ; i<m_Re_height ; i++){
			for(j=0 ; j<m_Re_width ; j++){
				m_OutputImage[i*m_Re_width + j] = m_InputImage[(i*dlg.m_DownSampleRate*m_width) + dlg.m_DownSampleRate*j];
			}
		}
	}
}

void CImageProcessingDoc::OnUpSampling()
{
	int i,j;

	CUpSampleDlg dlg;

	if(dlg.DoModal() == IDOK){
		m_Re_height = m_height * dlg.m_UpSampleRate;
		m_Re_width = m_width * dlg.m_UpSampleRate;
		m_Re_size = m_Re_height * m_Re_width;
			
		m_OutputImage = new unsigned char[m_Re_size];


		for(i=0 ; i<m_Re_size ; i++)
			m_OutputImage[i] = 0;
	
		for(i=0 ; i<m_height ; i++){
			for(j=0 ; j<m_width ; j++){
				m_OutputImage[i*dlg.m_UpSampleRate*m_Re_width + dlg.m_UpSampleRate*j] = m_InputImage[i*m_width + j];
			}
		}		
	}
}

void CImageProcessingDoc::OnQuantization()
{
	CQuantizationDlg dlg;


	if(dlg.DoModal() == IDOK)
	{
		int i, j, value, LEVEL;
		double HIGH, *TEMP;

		m_Re_height = m_height;
		m_Re_width = m_width;
		m_Re_size = m_Re_height * m_Re_width;

		m_OutputImage = new unsigned char[m_Re_size];
		TEMP = new double [m_size];
			
		LEVEL=256;
		HIGH=256.;

		value = (int)pow(2, dlg.m_QuantBit);

		for(i=0 ; i<m_size ; i++){
			for(j=0 ; j<value ; j++){
				if(m_InputImage[i]>=(LEVEL/value)*j && m_InputImage[i]<(LEVEL/value)*(j+1)){
					TEMP[i]=(double)(HIGH/value)*j;
				}
			}
		}

		for(i=0 ; i<m_size ; i++){
			m_OutputImage[i] = (unsigned char)TEMP[i];
		}
	}
}

void CImageProcessingDoc::OnSumConstant()
{
	CConstantDlg dlg;

	int i;

	m_Re_height = m_height;
	m_Re_width = m_width;
	m_Re_size = m_Re_height * m_Re_width;

	m_OutputImage = new unsigned char[m_Re_size];

	if(dlg.DoModal() == IDOK){
		for(i=0 ; i<m_size ; i++){
			if(m_InputImage[i] + dlg.m_Constant >= 255) // ° 255 ũų  255 
				m_OutputImage[i] = 255;
			else
				m_OutputImage [i] = (unsigned char)(m_InputImage[i] + dlg.m_Constant);
		}
	}
}

void CImageProcessingDoc::OnSubConstant()
{
	CConstantDlg dlg;

	int i;

	m_Re_height = m_height;
	m_Re_width = m_width;
	m_Re_size = m_Re_height * m_Re_width;

	m_OutputImage = new unsigned char[m_Re_size];

	if(dlg.DoModal() == IDOK){
		for(i=0 ; i<m_size ; i++){
			if(m_InputImage[i] - dlg.m_Constant < 0) // ° 0  0 
				m_OutputImage[i] = 0;
			else
				m_OutputImage [i] = (unsigned char)(m_InputImage[i] - dlg.m_Constant);
		}
	}
}

void CImageProcessingDoc::OnMulConstant()
{
	CConstantDlg dlg;

	int i;

	m_Re_height = m_height;
	m_Re_width = m_width;
	m_Re_size = m_Re_height * m_Re_width;

	m_OutputImage = new unsigned char[m_Re_size];

	if(dlg.DoModal() == IDOK){
		for(i=0 ; i<m_size ; i++){
			if(m_InputImage[i] * dlg.m_Constant > 255) // ° 255 ũ 255 
				m_OutputImage[i] = 255;
			else if(m_InputImage[i] * dlg.m_Constant < 0) // ° 0  0 
				m_OutputImage[i] = 0;
			else
				m_OutputImage [i] = (unsigned char)(m_InputImage[i] * dlg.m_Constant);
		}
	}
}

void CImageProcessingDoc::OnDivConstant()
{
	CConstantDlg dlg;

	int i;

	m_Re_height = m_height;
	m_Re_width = m_width;
	m_Re_size = m_Re_height * m_Re_width;

	m_OutputImage = new unsigned char[m_Re_size];

	if(dlg.DoModal() == IDOK){
		for(i=0 ; i<m_size ; i++){
			if(m_InputImage[i] / dlg.m_Constant > 255) // ° 255 ũ 255  
				m_OutputImage[i] = 255;
			else if(m_InputImage[i] / dlg.m_Constant < 0)// ° 0  0 
				m_OutputImage[i] = 0;
			else
				m_OutputImage [i] = (unsigned char)(m_InputImage[i] / dlg.m_Constant);
		}
	}
}

void CImageProcessingDoc::OnNegaTransform()
{
	int i;

	m_Re_height = m_height;
	m_Re_width = m_width;
	m_Re_size = m_Re_height * m_Re_width;

	m_OutputImage = new unsigned char[m_Re_size];

	for(i=0 ; i<m_size ; i++)
		m_OutputImage[i] = 255 - m_InputImage[i];
}

void CImageProcessingDoc::OnBinarization()
{
	CConstantDlg dlg;

	int i;

	m_Re_height = m_height;
	m_Re_width = m_width;
	m_Re_size = m_Re_height * m_Re_width;

	m_OutputImage = new unsigned char[m_Re_size];

	if(dlg.DoModal() == IDOK){
		for(i=0 ; i<m_size ; i++){
			if(m_InputImage[i] >= dlg.m_Constant) // Ӱ谪 ũ  255
				m_OutputImage[i] = 255; 
			else
				m_OutputImage[i] = 0; // Ӱ谪   0
		}
	}
}

void CImageProcessingDoc::OnGammaCorrection()
{
	CConstantDlg dlg;

	int i;
	double temp;

	m_Re_height = m_height;
	m_Re_width = m_width;
	m_Re_size = m_Re_height * m_Re_width;

	m_OutputImage = new unsigned char[m_Re_size];

	if(dlg.DoModal() == IDOK){
		for(i=0 ; i<m_size ; i++){
			temp = pow(m_InputImage[i], 1/dlg.m_Constant); // Gamma  

			if(temp < 0)
				m_OutputImage[i] = 0;
			else if(temp > 255)
				m_OutputImage[i] = 255;
			else
				m_OutputImage[i] = (unsigned char)temp;
		}
	}
}

void CImageProcessingDoc::OnStressTransform()
{
	CStressTransformDlg dlg;

	int i;

	m_Re_height = m_height;
	m_Re_width = m_width;
	m_Re_size = m_Re_height * m_Re_width;

	m_OutputImage = new unsigned char[m_Re_size];

	if(dlg.DoModal() == IDOK){
		for(i=0 ; i<m_size ; i++){
			if(m_InputImage[i] >= dlg.m_StartPoint && m_InputImage[i] <= dlg.m_EndPoint)
				// Է°  ۰  ᰪ ̿ ġϸ ° 255
				m_OutputImage[i] = 255;
			else
				m_OutputImage[i] = m_InputImage[i];
		}
	}
}

void CImageProcessingDoc::OnAndOperate()
{
	CConstantDlg dlg;
	int i;

	m_Re_height = m_height;
	m_Re_width = m_width;
	m_Re_size = m_Re_height * m_Re_width;


	m_OutputImage = new unsigned char[m_Re_size];

	if(dlg.DoModal() == IDOK){
		for(i=0 ; i<m_size ; i++){
			if((m_InputImage[i] & (unsigned char)dlg.m_Constant) >= 255){ // Ʈ  AND 
				m_OutputImage[i] = 255;
			}
			else if((m_InputImage[i] & (unsigned char)dlg.m_Constant) < 0){
				m_OutputImage[i] = 0;
			}
			else{
				m_OutputImage [i] = (m_InputImage[i] & (unsigned char)dlg.m_Constant);
			}
		}
	}
}

void CImageProcessingDoc::OnOrOperate()
{
	CConstantDlg dlg;
	int i;

	m_Re_height = m_height;
	m_Re_width = m_width;
	m_Re_size = m_Re_height * m_Re_width;

	m_OutputImage = new unsigned char[m_Re_size];

	if(dlg.DoModal() == IDOK){
		for(i=0 ; i<m_size ; i++){
			if((m_InputImage[i] | (unsigned char)dlg.m_Constant) >= 255){ // Ʈ  OR 
				m_OutputImage[i] = 255;
			}
			else if((m_InputImage[i] | (unsigned char)dlg.m_Constant) < 0){
				m_OutputImage[i] = 0;
			}
			else{
				m_OutputImage [i] = (m_InputImage[i] | (unsigned char)dlg.m_Constant);
			}
		}
	}
}

void CImageProcessingDoc::OnXorOperate()
{
	CConstantDlg dlg;
	int i;

	m_Re_height = m_height;
	m_Re_width = m_width;
	m_Re_size = m_Re_height * m_Re_width;

	m_OutputImage = new unsigned char[m_Re_size];

	if(dlg.DoModal() == IDOK){
		for(i=0 ; i<m_size ; i++){
			if((m_InputImage[i] ^ (unsigned char)dlg.m_Constant) >= 255){ // Ʈ  XOR 
				m_OutputImage[i] = 255;
			}
			else if((m_InputImage[i] ^ (unsigned char)dlg.m_Constant) < 0){
				m_OutputImage[i] = 0;
			}
			else{
				m_OutputImage [i] = (m_InputImage[i] ^ (unsigned char)dlg.m_Constant);
			}
		}
	}
}

