// ImageProcessingDoc.cpp : implementation of the CImageProcessingDoc class
//

#include "stdafx.h"
#include "ImageProcessing.h"

#include "ImageProcessingDoc.h"
#include "DownSampleDlg.h"
#include "UpSampleDlg.h"
#include "QuantizationDlg.h"
#include <math.h>
#include "ConstantDlg.h"
#include "StressTransformDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CImageProcessingDoc

IMPLEMENT_DYNCREATE(CImageProcessingDoc, CDocument)

BEGIN_MESSAGE_MAP(CImageProcessingDoc, CDocument)
	//{{AFX_MSG_MAP(CImageProcessingDoc)
		// NOTE - the ClassWizard will add and remove mapping macros here.
		//    DO NOT EDIT what you see in these blocks of generated code!
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CImageProcessingDoc construction/destruction

CImageProcessingDoc::CImageProcessingDoc()
{
	// TODO: add one-time construction code here

}

CImageProcessingDoc::~CImageProcessingDoc()
{
}

BOOL CImageProcessingDoc::OnNewDocument()
{
	if (!CDocument::OnNewDocument())
		return FALSE;

	// TODO: add reinitialization code here
	// (SDI documents will reuse this document)

	return TRUE;
}



/////////////////////////////////////////////////////////////////////////////
// CImageProcessingDoc serialization

void CImageProcessingDoc::Serialize(CArchive& ar)
{
	if (ar.IsStoring())
	{
		// TODO: add storing code here
	}
	else
	{
		// TODO: add loading code here
	}
}

/////////////////////////////////////////////////////////////////////////////
// CImageProcessingDoc diagnostics

#ifdef _DEBUG
void CImageProcessingDoc::AssertValid() const
{
	CDocument::AssertValid();
}

void CImageProcessingDoc::Dump(CDumpContext& dc) const
{
	CDocument::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CImageProcessingDoc commands



BOOL CImageProcessingDoc::OnOpenDocument(LPCTSTR lpszPathName) 
{
	if (!CDocument::OnOpenDocument(lpszPathName))
		return FALSE;
	
	CFile File;

	File.Open(lpszPathName, CFile::modeRead | CFile::typeBinary);

	if(File.GetLength() == 32*32){ // RAW  ũ 
			m_height = 32;
			m_width = 32;
		}
		else if(File.GetLength() == 64*64){ // RAW  ũ 
			m_height = 64;
			m_width = 64;
		}
		else if(File.GetLength() == 128*128){ // RAW  ũ 
			m_height = 128;
			m_width = 128;
		}
		else if(File.GetLength() == 256*256){ // RAW  ũ 
			m_height = 256;
			m_width = 256;
		}
		else if(File.GetLength() == 256*276){ // RAW  ũ 
			m_height = 276;
			m_width = 256;
		}
		else if(File.GetLength() == 512*512){ // RAW  ũ 
			m_height = 512;
			m_width = 512;		
		}
		else if(File.GetLength() == 640*480){ // RAW  ũ 
			m_height = 480;
			m_width = 640;
		}
		else if(File.GetLength() == 320*240){ // RAW  ũ 
			m_height = 240;
			m_width = 320;
		}
		else if(File.GetLength() == 176*144){// RAW  ũ 
			m_height = 144;
			m_width = 176;
		}
		else if(File.GetLength() == 176*216){ // RAW  ũ 
			m_height = 216;
			m_width = 176;
		}
		else{
			AfxMessageBox("Not Support Image Size"); //32*32, 64*64, 128*128, 256*256, 512*512, 640*480, 176*144 ũ ϸ 
			return 0;									 // Ÿ ̹ ũ ϶ 
		}

	m_size = m_width * m_height;

	m_InputImage = new unsigned char [m_size]; 
		
	for(int i = 0 ; i<m_size ; i++)
		m_InputImage[i] = 255;
		
	File.Read(m_InputImage, m_size); //  б 
	File.Close();
	
	return TRUE;
}

BOOL CImageProcessingDoc::OnSaveDocument(LPCTSTR lpszPathName) 
{
	CFile File;
	CFileDialog SaveDlg(FALSE, "raw", NULL, OFN_HIDEREADONLY);

	if(SaveDlg.DoModal() == IDOK){
		File.Open(SaveDlg.GetPathName(), CFile::modeCreate | CFile::modeWrite);
		File.Write(m_OutputImage, m_Re_size);
		File.Close();
	}
	
	return TRUE; 
}


void CImageProcessingDoc::OnDownSampling()
{
	int i, j;

	CDownSampleDlg dlg;
	
	if(dlg.DoModal() == IDOK)
	{
		m_Re_height = m_height / dlg.m_DownSampleRate;
		m_Re_width = m_width / dlg.m_DownSampleRate;
		m_Re_size = m_Re_height * m_Re_width;

		m_OutputImage = new unsigned char [m_Re_size];

		for(i=0 ; i<m_Re_size ; i++)
			m_OutputImage[i] = 255;

		for(i=0 ; i<m_Re_height ; i++){
			for(j=0 ; j<m_Re_width ; j++){
				m_OutputImage[i*m_Re_width + j] = m_InputImage[(i*dlg.m_DownSampleRate*m_width) + dlg.m_DownSampleRate*j];
			}
		}
	}
}

void CImageProcessingDoc::OnUpSampling()
{
	int i,j;

	CUpSampleDlg dlg;

	if(dlg.DoModal() == IDOK){
		m_Re_height = m_height * dlg.m_UpSampleRate;
		m_Re_width = m_width * dlg.m_UpSampleRate;
		m_Re_size = m_Re_height * m_Re_width;
			
		m_OutputImage = new unsigned char[m_Re_size];


		for(i=0 ; i<m_Re_size ; i++)
			m_OutputImage[i] = 0;
	
		for(i=0 ; i<m_height ; i++){
			for(j=0 ; j<m_width ; j++){
				m_OutputImage[i*dlg.m_UpSampleRate*m_Re_width + dlg.m_UpSampleRate*j] = m_InputImage[i*m_width + j];
			}
		}		
	}
}

void CImageProcessingDoc::OnQuantization()
{
	CQuantizationDlg dlg;

	m_Re_height = m_height;
	m_Re_width = m_width;
	m_Re_size = m_Re_height * m_Re_width;

	m_OutputImage = new unsigned char[m_Re_size];

	if(dlg.DoModal() == IDOK)
	{
		int i, j, value, LEVEL;
		double HIGH, *TEMP;

		TEMP = new double [m_size];
			
		LEVEL=256;
		HIGH=256.;

		value = (int)pow(2, dlg.m_QuantBit);

		for(i=0 ; i<m_size ; i++){
			for(j=0 ; j<value ; j++){
				if(m_InputImage[i]>=(LEVEL/value)*j && m_InputImage[i]<(LEVEL/value)*(j+1)){
					TEMP[i]=(double)(HIGH/value)*j;
				}
			}
		}

		for(i=0 ; i<m_size ; i++){
			m_OutputImage[i] = (unsigned char)TEMP[i];
		}
	}
}

void CImageProcessingDoc::OnSumConstant()
{
	CConstantDlg dlg;

	int i;

	m_Re_height = m_height;
	m_Re_width = m_width;
	m_Re_size = m_Re_height * m_Re_width;

	m_OutputImage = new unsigned char[m_Re_size];

	if(dlg.DoModal() == IDOK){
		for(i=0 ; i<m_size ; i++){
			if(m_InputImage[i] + dlg.m_Constant >= 255)
				m_OutputImage[i] = 255;
			else
				m_OutputImage [i] = (unsigned char)(m_InputImage[i] + dlg.m_Constant);
		}
	}
}

void CImageProcessingDoc::OnSubConstant()
{
	CConstantDlg dlg;

	int i;

	m_Re_height = m_height;
	m_Re_width = m_width;
	m_Re_size = m_Re_height * m_Re_width;

	m_OutputImage = new unsigned char[m_Re_size];

	if(dlg.DoModal() == IDOK){
		for(i=0 ; i<m_size ; i++){
			if(m_InputImage[i] - dlg.m_Constant < 0)
				m_OutputImage[i] = 0;
			else
				m_OutputImage [i] = (unsigned char)(m_InputImage[i] - dlg.m_Constant);
		}
	}
}

void CImageProcessingDoc::OnMulConstant()
{
	CConstantDlg dlg;

	int i;

	m_Re_height = m_height;
	m_Re_width = m_width;
	m_Re_size = m_Re_height * m_Re_width;

	m_OutputImage = new unsigned char[m_Re_size];

	if(dlg.DoModal() == IDOK){
		for(i=0 ; i<m_size ; i++){
			if(m_InputImage[i] * dlg.m_Constant > 255)
				m_OutputImage[i] = 255;
			else if(m_InputImage[i] * dlg.m_Constant < 0)
				m_OutputImage[i] = 0;
			else
				m_OutputImage [i] = (unsigned char)(m_InputImage[i] * dlg.m_Constant);
		}
	}
}

void CImageProcessingDoc::OnDivConstant()
{
	CConstantDlg dlg;

	int i;

	m_Re_height = m_height;
	m_Re_width = m_width;
	m_Re_size = m_Re_height * m_Re_width;

	m_OutputImage = new unsigned char[m_Re_size];

	if(dlg.DoModal() == IDOK){
		for(i=0 ; i<m_size ; i++){
			if(m_InputImage[i] / dlg.m_Constant > 255)
				m_OutputImage[i] = 255;
			else if(m_InputImage[i] / dlg.m_Constant < 0)
				m_OutputImage[i] = 0;
			else
				m_OutputImage [i] = (unsigned char)(m_InputImage[i] / dlg.m_Constant);
		}
	}
}

void CImageProcessingDoc::OnNegaTransform()
{
	int i;

	m_Re_height = m_height;
	m_Re_width = m_width;
	m_Re_size = m_Re_height * m_Re_width;

	m_OutputImage = new unsigned char[m_Re_size];

	for(i=0 ; i<m_size ; i++)
		m_OutputImage[i] = 255 - m_InputImage[i];
}

void CImageProcessingDoc::OnBinarization()
{
	CConstantDlg dlg;

	int i;

	m_Re_height = m_height;
	m_Re_width = m_width;
	m_Re_size = m_Re_height * m_Re_width;

	m_OutputImage = new unsigned char[m_Re_size];

	if(dlg.DoModal() == IDOK){
		for(i=0 ; i<m_size ; i++){
			if(m_InputImage[i] >= dlg.m_Constant)
				m_OutputImage[i] = 255;
			else
				m_OutputImage[i] = 0;
		}
	}
}

void CImageProcessingDoc::OnGammaCorrection()
{
	CConstantDlg dlg;

	int i;
	double temp;

	m_Re_height = m_height;
	m_Re_width = m_width;
	m_Re_size = m_Re_height * m_Re_width;

	m_OutputImage = new unsigned char[m_Re_size];

	if(dlg.DoModal() == IDOK){
		for(i=0 ; i<m_size ; i++){
			temp = pow(m_InputImage[i], 1/dlg.m_Constant);

			if(temp < 0)
				m_OutputImage[i] = 0;
			else if(temp > 255)
				m_OutputImage[i] = 255;
			else
				m_OutputImage[i] = (unsigned char)temp;
		}
	}
}

void CImageProcessingDoc::OnStressTransform()
{
	CStressTransformDlg dlg;

	int i;

	m_Re_height = m_height;
	m_Re_width = m_width;
	m_Re_size = m_Re_height * m_Re_width;

	m_OutputImage = new unsigned char[m_Re_size];

	if(dlg.DoModal() == IDOK){
		for(i=0 ; i<m_size ; i++){
			if(m_InputImage[i] >= dlg.m_StartPoint && m_InputImage[i] <= dlg.m_EndPoint 
			   || m_InputImage[i] <= dlg.m_StartPoint && m_InputImage[i] >= dlg.m_EndPoint)
				m_OutputImage[i] = 255;
			else
				m_OutputImage[i] = m_InputImage[i];
		}
	}
}

void CImageProcessingDoc::OnAndOperate()
{
	CConstantDlg dlg;
	int i;

	m_Re_height = m_height;
	m_Re_width = m_width;
	m_Re_size = m_Re_height * m_Re_width;


	m_OutputImage = new unsigned char[m_Re_size];

	if(dlg.DoModal() == IDOK){
		for(i=0 ; i<m_size ; i++){
			if((m_InputImage[i] & (unsigned char)dlg.m_Constant) >= 255){
				m_OutputImage[i] = 255;
			}
			else if((m_InputImage[i] & (unsigned char)dlg.m_Constant) < 0){
				m_OutputImage[i] = 0;
			}
			else{
				m_OutputImage [i] = (m_InputImage[i] & (unsigned char)dlg.m_Constant);
			}
		}
	}
}

void CImageProcessingDoc::OnOrOperate()
{
	CConstantDlg dlg;
	int i;

	m_Re_height = m_height;
	m_Re_width = m_width;
	m_Re_size = m_Re_height * m_Re_width;


	m_OutputImage = new unsigned char[m_Re_size];

	if(dlg.DoModal() == IDOK){
		for(i=0 ; i<m_size ; i++){
			if((m_InputImage[i] | (unsigned char)dlg.m_Constant) >= 255){
				m_OutputImage[i] = 255;
			}
			else if((m_InputImage[i] | (unsigned char)dlg.m_Constant) < 0){
				m_OutputImage[i] = 0;
			}
			else{
				m_OutputImage [i] = (m_InputImage[i] | (unsigned char)dlg.m_Constant);
			}
		}
	}
}

void CImageProcessingDoc::OnXorOperate()
{
	CConstantDlg dlg;
	int i;

	m_Re_height = m_height;
	m_Re_width = m_width;
	m_Re_size = m_Re_height * m_Re_width;


	m_OutputImage = new unsigned char[m_Re_size];

	if(dlg.DoModal() == IDOK){
		for(i=0 ; i<m_size ; i++){
			if((m_InputImage[i] ^ (unsigned char)dlg.m_Constant) >= 255){
				m_OutputImage[i] = 255;
			}
			else if((m_InputImage[i] ^ (unsigned char)dlg.m_Constant) < 0){
				m_OutputImage[i] = 0;
			}
			else{
				m_OutputImage [i] = (m_InputImage[i] ^ (unsigned char)dlg.m_Constant);
			}
		}
	}
}


void CImageProcessingDoc::OnHistogram()
{
	// ׷  0 ~ 255
	// ׷ ũⰪ MAX = 255 ȭ Ͽ 
	// Ʈ׷ ũ : 256 * 256 

	int i, j, value;
	unsigned char LOW, HIGH;
	double MAX, MIN, DIF;
	
	m_Re_height = 256;
	m_Re_width = 256;
	m_Re_size = m_Re_height * m_Re_width;

	LOW = 0;
	HIGH = 255;
	
	//ʱȭ
	for(i=0 ; i<256 ; i++)
		m_HIST[i] = LOW;
	
	
	//󵵼 
	for(i=0 ; i<m_size ; i++){
		value = (int)m_InputImage[i];
		m_HIST[value]++;
	}

	// ȭ
	MAX = m_HIST[0];
	MIN = m_HIST[0];

	for(i=0 ; i<256 ; i++){
		if(m_HIST[i] > MAX)
			MAX = m_HIST[i];

	}
	
	for(i=0 ; i<256 ; i++){
		if(m_HIST[i] < MIN)
			MIN = m_HIST[i];
	}
	
	DIF = MAX - MIN;

	for(i=0 ; i<256 ; i++)
		m_Scale_HIST[i] = (unsigned char)((m_HIST[i] - MIN) * HIGH / DIF);


	// ׷ 

	m_OutputImage = new unsigned char [m_Re_size + (256*20)];

	for(i=0 ; i<m_Re_size ; i++)
		m_OutputImage[i] = 255;

			
	for(i=0 ; i<256 ; i++){
		for(j = 0 ; j<m_Scale_HIST[i] ; j++){
			m_OutputImage[m_Re_width*(m_Re_height-j-1) + i] = 0;		
		}
	}

	for(i = m_Re_height ; i<m_Re_height + 5 ; i++){
		for(j=0 ; j<256 ; j++){
			m_OutputImage[m_Re_height * i + j] = 255;
		}
	}
	
	for(i = m_Re_height+5 ; i<m_Re_height + 20 ; i++){
		for(j=0 ; j<256 ; j++){
			m_OutputImage[m_Re_height * i + j] = j;
		}
	}

	m_Re_height = m_Re_height + 20;
	m_Re_size = m_Re_height * m_Re_width;
	
}




void CImageProcessingDoc::OnHistoEqual()
{
	int i, value;
	unsigned char LOW, HIGH, Temp;
	double SUM = 0.0;
	
	m_Re_height = m_height;
	m_Re_width = m_width;
	m_Re_size = m_Re_height * m_Re_width;


	LOW = 0;
	HIGH = 255;
	
	//ʱȭ
	for(i=0 ; i<256 ; i++)
		m_HIST[i] = LOW;

	
	//󵵼 
	for(i=0 ; i<m_size ; i++){
		value = (int)m_InputImage[i];
		m_HIST[value]++;
	}

	for(i=0 ; i<256 ; i++){
		SUM += m_HIST[i];
		m_Sum_Of_HIST[i] = SUM;
	}
	
	m_OutputImage = new unsigned char[m_Re_size];

	
	for(i=0 ; i<m_size ; i++){
		Temp = m_InputImage[i];
		m_OutputImage[i]=(unsigned char)(m_Sum_Of_HIST[Temp]*HIGH/m_size);
	}
}

void CImageProcessingDoc::OnHistoStretch()
{
	int i;
	unsigned char LOW, HIGH, MAX, MIN;
		
	m_Re_height = m_height;
	m_Re_width = m_width;
	m_Re_size = m_Re_height * m_Re_width;

	LOW = 0;
	HIGH = 255;
	
	
	MIN = m_InputImage[0];
	MAX = m_InputImage[0];

	for(i=0 ; i<m_size ; i++){
		if(m_InputImage[i] < MIN)
			MIN = m_InputImage[i];
	}

	for(i=0 ; i<m_size ; i++){
		if(m_InputImage[i] > MAX)
			MAX = m_InputImage[i];
	}
	
	m_OutputImage = new unsigned char[m_Re_size];

	for(i=0 ; i<m_size ; i++)
		m_OutputImage[i] = (unsigned char)((m_InputImage[i] - MIN)*HIGH / (MAX-MIN));
}

void CImageProcessingDoc::OnEndInSearch()
{
	int i;
	unsigned char LOW, HIGH, MAX, MIN;
		
	m_Re_height = m_height;
	m_Re_width = m_width;
	m_Re_size = m_Re_height * m_Re_width;

	LOW = 0;
	HIGH = 255;
	
	
	MIN = m_InputImage[0];
	MAX = m_InputImage[0];

	for(i=0 ; i<m_size ; i++){
		if(m_InputImage[i] < MIN)
			MIN = m_InputImage[i];
	}

	for(i=0 ; i<m_size ; i++){
		if(m_InputImage[i] > MAX)
			MAX = m_InputImage[i];
	}
	
	m_OutputImage = new unsigned char[m_Re_size];

	for(i=0 ; i<m_size ; i++){
		if(m_InputImage[i] <= MIN){
			m_OutputImage[i] = 0;
		}
		else if(m_InputImage[i] >= MAX){
			m_OutputImage[i] = 255;
		}
		else
			m_OutputImage[i] = (unsigned char)((m_InputImage[i] - MIN)*HIGH / (MAX-MIN));
	}

}

void CImageProcessingDoc::OnHistoSpec()
{
	int i, value, Dvalue, top, bottom, DADD;
	unsigned char *m_DTEMP, m_Sum_Of_ScHIST[256], m_TABLE[256];
	unsigned char LOW, HIGH, Temp, *m_Org_Temp;
	double m_DHIST[256], m_Sum_Of_DHIST[256], SUM = 0.0, DSUM = 0.0;
	double DMAX, DMIN;

	top = 255;
	bottom = top - 1;

	m_Re_height = m_height;
	m_Re_width = m_width;
	m_Re_size = m_Re_height * m_Re_width;
	
	m_Org_Temp = new unsigned char [m_size];
	m_OutputImage = new unsigned char [m_Re_size];
	
	CFile File; 
	CFileDialog OpenDlg(TRUE);

	if(OpenDlg.DoModal() == IDOK){
		File.Open(OpenDlg.GetFileName(), CFile::modeRead);
		
		if(File.GetLength() == (unsigned)m_size){
			m_DTEMP = new unsigned char[m_size];
			File.Read(m_DTEMP, m_size);
			File.Close();
		}
		else{
			AfxMessageBox("Image size not matched");
			return;
		}
	}

	LOW = 0;
	HIGH = 255;
	
	//ʱȭ
	for(i=0 ; i<256 ; i++){
		m_HIST[i] = LOW;
		m_DHIST[i] = LOW;
		m_TABLE[i] = LOW;
	}

	//󵵼 
	for(i=0 ; i<m_size ; i++){
		value = (int)m_InputImage[i];
		m_HIST[value]++;
		Dvalue = (int)m_DTEMP[i];
		m_DHIST[Dvalue]++;
	}

	for(i=0 ; i<256 ; i++){
		SUM += m_HIST[i];
		m_Sum_Of_HIST[i] = SUM;
		DSUM += m_DHIST[i];
		m_Sum_Of_DHIST[i] = DSUM;
	}
	

	for(i=0 ; i<m_size ; i++){
		Temp = m_InputImage[i];
		m_Org_Temp[i]=(unsigned char)(m_Sum_Of_HIST[Temp]*HIGH/m_size);
	}

	DMIN = m_Sum_Of_DHIST[0];
	DMAX = m_Sum_Of_DHIST[255];

	for(i=0 ; i<256 ; i++){
		m_Sum_Of_ScHIST[i]=(unsigned char)((m_Sum_Of_DHIST[i]-DMIN)*HIGH/(DMAX - DMIN));
	}
	
	for( ; ; ){
		for(i=m_Sum_Of_ScHIST[bottom] ; i <= m_Sum_Of_ScHIST[top] ; i++){
			m_TABLE[i] = top;
		}
		top = bottom;
		bottom = bottom - 1;

		if(bottom < -1)
			break;
	}

	for(i=0 ; i<m_size ; i++){
		DADD = (int)m_Org_Temp[i];
		m_OutputImage[i] = m_TABLE[DADD];
	}
}



void CImageProcessingDoc::OnEmbossing()
{
	int i, j;
	double EmboMask[3][3] = {{-1., 0., 0.}, {0., 0., 0.}, {0., 0., 1.}};
	
	m_Re_height = m_height;
	m_Re_width = m_width;
	m_Re_size = m_Re_height * m_Re_width;

	m_OutputImage = new unsigned char [m_Re_size];

	m_tempImage = OnMaskProcess(m_InputImage, EmboMask);

	//m_tempImage = OnScale(m_tempImage, m_Re_height, m_Re_width);

	for(i=0 ; i<m_Re_height ; i++){
		for(j=0 ; j<m_Re_width ; j++){
			if(m_tempImage[i][j] > 255.)
				m_tempImage[i][j] = 255.;
			if(m_tempImage[i][j] < 0.)
				m_tempImage[i][j] = 0.;
		}
	}

	for(i=0 ; i<m_Re_height ; i++){
		for(j=0 ; j<m_Re_width ; j++){
			m_OutputImage[i*m_Re_width + j] = (unsigned char)m_tempImage[i][j];
		}
	}
}

void CImageProcessingDoc::OnBlurr()
{
	int i, j;
	double BlurrMask[3][3] = {{1./9., 1./9., 1./9.}, {1./9., 1./9., 1./9.}, {1./9., 1./9., 1./9.}};

	m_Re_height = m_height;
	m_Re_width = m_width;
	m_Re_size = m_Re_height * m_Re_width;

	m_OutputImage = new unsigned char [m_Re_size];

	m_tempImage = OnMaskProcess(m_InputImage, BlurrMask);

	//m_tempImage = OnScale(m_tempImage, m_Re_height, m_Re_width);

	for(i=0 ; i<m_Re_height ; i++){
		for(j=0 ; j<m_Re_width ; j++){
			if(m_tempImage[i][j] > 255.)
				m_tempImage[i][j] = 255.;
			if(m_tempImage[i][j] < 0.)
				m_tempImage[i][j] = 0.;
		}
	}

	for(i=0 ; i<m_Re_height ; i++){
		for(j=0 ; j<m_Re_width ; j++){
			m_OutputImage[i*m_Re_width + j] = (unsigned char)m_tempImage[i][j];
		}
	}
}



void CImageProcessingDoc::OnGaussianFilter()
{
	int i, j;
	double GaussianMask[3][3] = {{1./16., 1./8., 1./16.}, {1./8., 1./4., 1./8.}, {1./16., 1./8., 1./16.}};

	m_Re_height = m_height;
	m_Re_width = m_width;
	m_Re_size = m_Re_height * m_Re_width;

	m_OutputImage = new unsigned char [m_Re_size];

	m_tempImage = OnMaskProcess(m_InputImage, GaussianMask);

	//m_tempImage = OnScale(m_tempImage, m_Re_height, m_Re_width);

	for(i=0 ; i<m_Re_height ; i++){
		for(j=0 ; j<m_Re_width ; j++){
			if(m_tempImage[i][j] > 255.)
				m_tempImage[i][j] = 255.;
			if(m_tempImage[i][j] < 0.)
				m_tempImage[i][j] = 0.;
		}
	}

	for(i=0 ; i<m_Re_height ; i++){
		for(j=0 ; j<m_Re_width ; j++){
			m_OutputImage[i*m_Re_width + j] = (unsigned char)m_tempImage[i][j];
		}
	}
}

void CImageProcessingDoc::OnSharpening()
{
	int i, j;
	//double SharpeningMask[3][3] = {{-1., -1., -1.}, {-1., 8., -1.}, {-1., -1., -1.}};
	double SharpeningMask[3][3] = {{0., -1., 0.}, {-1., 5., -1.}, {0., -1., 0.}};

	m_Re_height = m_height;
	m_Re_width = m_width;
	m_Re_size = m_Re_height * m_Re_width;

	m_OutputImage = new unsigned char [m_Re_size];

	m_tempImage = OnMaskProcess(m_InputImage, SharpeningMask);

	for(i=0 ; i<m_Re_height ; i++){
		for(j=0 ; j<m_Re_width ; j++){
			if(m_tempImage[i][j] > 255.)
				m_tempImage[i][j] = 255.;
			if(m_tempImage[i][j] < 0.)
				m_tempImage[i][j] = 0.;
		}
	}
	//m_tempImage = OnScale(m_tempImage, m_Re_height, m_Re_width);

	for(i=0 ; i<m_Re_height ; i++){
		for(j=0 ; j<m_Re_width ; j++){
			m_OutputImage[i*m_Re_width + j] = (unsigned char)m_tempImage[i][j];
		}
	}
}

void CImageProcessingDoc::OnHpfSharp()
{
	int i, j;
	double HpfSharpMask[3][3] = {{-1./9., -1./9., -1./9.}, {-1./9., 8./9., -1./9.}, {-1./9., -1./9., -1./9.}};
	
	m_Re_height = m_height;
	m_Re_width = m_width;
	m_Re_size = m_Re_height * m_Re_width;

	m_OutputImage = new unsigned char [m_Re_size];

	m_tempImage = OnMaskProcess(m_InputImage, HpfSharpMask);

	for(i=0 ; i<m_Re_height ; i++){
		for(j=0 ; j<m_Re_width ; j++){
			if(m_tempImage[i][j] > 255.)
				m_tempImage[i][j] = 255.;
			if(m_tempImage[i][j] < 0.)
				m_tempImage[i][j] = 0.;
		}
	}
	//m_tempImage = OnScale(m_tempImage, m_Re_height, m_Re_width);

	for(i=0 ; i<m_Re_height ; i++){
		for(j=0 ; j<m_Re_width ; j++){
			m_OutputImage[i*m_Re_width + j] = (unsigned char)m_tempImage[i][j];
		}
	}
}

void CImageProcessingDoc::OnLpfSharp()
{
	CConstantDlg dlg;

	int i, j, alpha;
	double LpfSharpMask[3][3] = {{1./9., 1./9., 1./9.}, {1./9., 1./9., 1./9.}, {1./9., 1./9., 1./9.}};
	
	m_Re_height = m_height;
	m_Re_width = m_width;
	m_Re_size = m_Re_height * m_Re_width;

	m_OutputImage = new unsigned char [m_Re_size];

	if(dlg.DoModal() == IDOK){
		alpha = (int)dlg.m_Constant;
	}
	
	m_tempImage = OnMaskProcess(m_InputImage, LpfSharpMask);

	for(i=0 ; i<m_height ; i++){
		for(j=0 ; j<m_width ; j++){
			m_tempImage[i][j] = (alpha * m_InputImage[i*m_width + j]) - (unsigned char)m_tempImage[i][j];
		}
	}

	for(i=0 ; i<m_Re_height ; i++){
		for(j=0 ; j<m_Re_width ; j++){
			if(m_tempImage[i][j] > 255.)
				m_tempImage[i][j] = 255.;
			if(m_tempImage[i][j] < 0.)
				m_tempImage[i][j] = 0.;
		}
	}
	//m_tempImage = OnScale(m_tempImage, m_Re_height, m_Re_width);


	for(i=0 ; i<m_Re_height ; i++){
		for(j=0 ; j<m_Re_width ; j++){
			m_OutputImage[i*m_Re_width + j] = (unsigned char)m_tempImage[i][j];
		}
	}
}

double** CImageProcessingDoc::Image2DMem(int height, int width)
{
	double** temp;
	int i, j;

	temp = new double *[height];

	for(i=0 ; i<height ; i++){
		temp[i] = new double [width];
	}

	for(i=0 ; i<height ; i++){
		for(j=0 ; j<width ; j++){
			temp[i][j] = 0.0;
		}
	}

	return temp;
}

double** CImageProcessingDoc::OnScale(double **Target, int height, int width)
{
	int i, j;
	double min, max;
		
	min = max = Target[0][0];
	
	for(i=0 ; i<height ; i++){
		for(j=0 ; j<width ; j++){
			if(Target[i][j] <= min){
				min = Target[i][j];
			}
			
			if(Target[i][j] >= max){
					max = Target[i][j];
			}
		}
	}
	
	max = max - min;
	
	for(i=0 ; i<height ; i++){
		for(j=0 ; j<width ; j++){
			Target[i][j] = (Target[i][j] - min) * (255. / max);
		}
	}
	return Target;
}

double** CImageProcessingDoc::OnMaskProcess(unsigned char* Target, double Mask[3][3])
{
	int i, j, n, m; 
	double **tempInputImage, **tempOutputImage, S = 0.0;

	tempInputImage = Image2DMem(m_height + 2, m_width + 2);
	tempOutputImage = Image2DMem(m_height, m_width);

	for(i=0 ; i<m_height ; i++){
		for(j=0 ; j<m_width ; j++){
			tempInputImage[i+1][j+1] = (double)Target[i * m_width + j];
		}
	}

	for(i=0 ; i<m_height ; i++){
		for(j=0 ; j<m_width ; j++){
			for(n=0 ; n<3 ; n++){
				for(m=0 ; m<3 ; m++){
					S += Mask[n][m] * tempInputImage[i+n][j+m];
				}
			}
			tempOutputImage[i][j] = S;
			S = 0.0;
		}
	}

	return tempOutputImage;
}


void CImageProcessingDoc::OnDiffOperatorHor()
{
	int i, j;
	//double DiffHorMask[3][3] = {{0., -1., 0.}, {0., 1., 0.}, {0., 0., 0.}};
	double DiffHorMask[3][3] = {{1., 0., -1.}, {1., 0., -1.}, {1., 0., -1.}};
	
	m_Re_height = m_height;
	m_Re_width = m_width;
	m_Re_size = m_Re_height * m_Re_width;
	m_OutputImage = new unsigned char [m_Re_size];

	m_tempImage = OnMaskProcess(m_InputImage, DiffHorMask);
	//m_tempImage = OnScale(m_tempImage, m_Re_height, m_Re_width);
	
	for(i=0 ; i<m_Re_height ; i++){
		for(j=0 ; j<m_Re_width ; j++){
			if(m_tempImage[i][j] > 255.)
				m_tempImage[i][j] = 255.;
			if(m_tempImage[i][j] < 0.)
				m_tempImage[i][j] = 0.;
		}
	}

	for(i=0 ; i<m_Re_height ; i++){
		for(j=0 ; j<m_Re_width ; j++){
			m_OutputImage[i*m_Re_width + j] = (unsigned char)m_tempImage[i][j];
		}
	}
}

void CImageProcessingDoc::OnDiffOperatorVer()
{
	int i, j, temp;
	//double DiffVerMask[3][3] = {{0., 0., 0.}, {-1., 1., 0.}, {0., 0., 0.}};
	double DiffVerMask[3][3] = {{1., 1., 1.}, {0., 0., 0.}, {-1., -1., -1.}};
	unsigned char *m_tempTrans;
	double **m_tempTransRev;

	m_Re_height = m_height;
	m_Re_width = m_width;
	m_Re_size = m_Re_height * m_Re_width;
	
	m_OutputImage = new unsigned char [m_Re_size];
	m_tempTrans = new unsigned char [m_size];
	m_tempTransRev = Image2DMem(m_height, m_width);


	for(i=0 ; i<m_height ; i++){
		for(j=0 ; j<m_width ; j++){
			m_tempTrans[j*m_height + i] = m_InputImage[i*m_width + j];
		}
	}

	temp = m_height;
	m_height = m_width;
	m_width = temp;
	
	m_tempImage = OnMaskProcess(m_tempTrans, DiffVerMask);

	for(i=0 ; i<m_Re_height ; i++){
		for(j=0 ; j<m_Re_width ; j++){
			if(m_tempImage[i][j] > 255.)
				m_tempImage[i][j] = 255.;
			if(m_tempImage[i][j] < 0.)
				m_tempImage[i][j] = 0.;
		}
	}

	for(i=0 ; i<m_height ; i++){
		for(j=0 ; j<m_width ; j++){
			m_tempTransRev[j][i] = m_tempImage[i][j];
		}
	}

	temp = m_height;
	m_height = m_width;
	m_width = temp;
	
	//m_tempTransRev = OnScale(m_tempTransRev, m_Re_height, m_Re_width);

	for(i=0 ; i<m_Re_height ; i++){
		for(j=0 ; j<m_Re_width ; j++){
			m_OutputImage[i*m_Re_width + j] = (unsigned char)m_tempTransRev[i][j];
		}
	}
}

void CImageProcessingDoc::OnHomogenOperator()
{
	int i, j, n, m;
	double max, **tempOutputImage;

	m_Re_height = m_height;
	m_Re_width = m_width;
	m_Re_size = m_Re_height * m_Re_width;
	m_OutputImage = new unsigned char [m_Re_size];
	
	m_tempImage = Image2DMem(m_height + 2, m_width + 2);
	tempOutputImage = Image2DMem(m_Re_height, m_Re_width);

	for(i=0 ; i<m_height ; i++){
		for(j=0 ; j<m_width ; j++){
			m_tempImage[i+1][j+1] = (double)m_InputImage[i * m_width + j];
		}
	}

	for(i=0 ; i<m_height ; i++){
		for(j=0 ; j<m_width ; j++){
			max = 0.0;
			for(n=0 ; n<3 ; n++){
				for(m=0 ; m<3 ; m++){
					if(DoubleABS(m_tempImage[i+1][j+1] - m_tempImage[i+n][j+m]) >= max)
						max = DoubleABS(m_tempImage[i+1][j+1] - m_tempImage[i+n][j+m]);
				}
			}
			tempOutputImage[i][j] = max;
		}
	}

	for(i=0 ; i<m_Re_height ; i++){
		for(j=0 ; j<m_Re_width ; j++){
			if(tempOutputImage[i][j] > 255.)
				tempOutputImage[i][j] = 255.;
			if(tempOutputImage[i][j] < 0.)
				tempOutputImage[i][j] = 0.;
		}
	}

	for(i=0 ; i<m_Re_height ; i++){
		for(j=0 ; j<m_Re_width ; j++){
			m_OutputImage[i*m_Re_width + j] = (unsigned char)tempOutputImage[i][j];
		}
	}
}


double CImageProcessingDoc::DoubleABS(double X)
{
	if(X >= 0)
		return X;
	else
		return -X;

}



void CImageProcessingDoc::OnLaplacian()
{
	int i, j;
	double LaplacianMask[3][3] = {{0., 1., 0.}, {1., -4., 1.}, {0., 1., 0.}};
	
	m_Re_height = m_height;
	m_Re_width = m_width;
	m_Re_size = m_Re_height * m_Re_width;
	m_OutputImage = new unsigned char [m_Re_size];

	m_tempImage = OnMaskProcess(m_InputImage, LaplacianMask);

	//m_tempImage = OnScale(m_tempImage, m_Re_height, m_Re_width);

	for(i=0 ; i<m_Re_height ; i++){
		for(j=0 ; j<m_Re_width ; j++){
			if(m_tempImage[i][j] > 255.)
				m_tempImage[i][j] = 255.;
			if(m_tempImage[i][j] < 0.)
				m_tempImage[i][j] = 0.;
		}
	}

	for(i=0 ; i<m_Re_height ; i++){
		for(j=0 ; j<m_Re_width ; j++){
			m_OutputImage[i*m_Re_width + j] = (unsigned char)m_tempImage[i][j];
		}
	}
}

void CImageProcessingDoc::OnNearest()
{
	int i,j;
	int ZoomRate = 2;
	double **tempArray;
	
	m_Re_height = int(ZoomRate*m_height);
	m_Re_width = int(ZoomRate*m_width);
	m_Re_size = m_Re_height * m_Re_width;
	
	m_tempImage = Image2DMem(m_height, m_width);
	tempArray = Image2DMem(m_Re_height, m_Re_width);
	m_OutputImage = new unsigned char [m_Re_size];

	for(i=0 ; i<m_height ; i++){
		for(j=0 ; j<m_width ; j++){
			m_tempImage[i][j] = (double)m_InputImage[i*m_width + j];
		}
	}

	for(i=0 ; i<m_Re_height ; i++){
		for(j=0 ; j<m_Re_width ; j++){
			tempArray[i][j] = m_tempImage[i/ZoomRate][j/ZoomRate];
		}
	}

	for(i=0 ; i<m_Re_height ; i++){
		for(j=0 ; j<m_Re_width ; j++){
			m_OutputImage[i*m_Re_width + j] = (unsigned char)tempArray[i][j];
		}
	}
}

void CImageProcessingDoc::OnBilinear()
{
	int i, j, point, i_H, i_W;
	unsigned char newValue;
	double ZoomRate = 2.0, r_H, r_W, s_H, s_W;
	double C1, C2, C3, C4;

	m_Re_height = (int)(m_height * ZoomRate);
	m_Re_width = (int)(m_width * ZoomRate);
	m_Re_size = m_Re_height * m_Re_width;
	
	m_tempImage = Image2DMem(m_height, m_width);

	m_OutputImage = new unsigned char [m_Re_size];

	for(i=0 ; i<m_height ; i++){
		for(j=0 ; j<m_width ; j++){
			m_tempImage[i][j] = (double)m_InputImage[i*m_width + j];
		}
	}

	for(i=0 ; i<m_Re_height ; i++){
		for(j=0 ; j<m_Re_width ; j++){
			r_H = i / ZoomRate;
			r_W = j / ZoomRate;

			i_H = (int)floor(r_H);
			i_W = (int)floor(r_W);
			
			s_H = r_H - i_H;
			s_W = r_W - i_W;
			
			if(i_H < 0 || i_H >= (m_height-1) || i_W < 0 || i_W >= (m_width-1))
			{
				point = i*m_Re_width + j;
				m_OutputImage[point] = 255;
			}
			
			else
			{
				C1 = (double)m_tempImage[i_H][i_W];
				C2 = (double)m_tempImage[i_H][i_W+1];
				C3 = (double)m_tempImage[i_H+1][i_W+1];
				C4 = (double)m_tempImage[i_H+1][i_W];

				newValue = (unsigned char)(C1*(1-s_H)*(1-s_W)+C2*s_W*(1-s_H)+C3*s_W*s_H+C4*(1-s_W)*s_H);
				point = i*m_Re_width+j;
				m_OutputImage[point] = newValue;
			}
		}
	}
}


void CImageProcessingDoc::OnMedianSub()
{
	int i, j,n, m, M = 2, index = 0;
	double *Mask, Value;

	Mask = new double [M*M];

	m_Re_height = (m_height + 1) / M;
	m_Re_width = (m_width + 1) / M;
	m_Re_size = m_Re_height * m_Re_width;

	m_OutputImage = new unsigned char [m_Re_size];
	
	m_tempImage = Image2DMem(m_height + 1, m_width + 1);


	for(i=0 ; i<m_height ; i++){
		for(j=0 ; j<m_width ; j++){
			m_tempImage[i][j] = (double)m_InputImage[i*m_width + j];
		}
	}

	for(i=0 ; i<m_height-1 ; i=i+M){
		for(j=0 ; j<m_width-1 ; j=j+M){
			for(n=0 ; n<M ; n++){
				for(m=0 ; m<M ; m++){
					Mask[n*M + m] = m_tempImage[i+n][j+m];
				}
			}
			OnBubleSort(Mask, M*M);
			Value = Mask[(int)(M*M/2)];
			m_OutputImage[index] = (unsigned char)Value;
			index++;
			
		}
	}
}

void CImageProcessingDoc::OnBubleSort(double * A, int MAX)
{
	int i, j;

	for(i=0 ; i<MAX ; i++){
		for(j=0 ; j<MAX-1 ; j++){
			if(A[j] > A[j+1]){
				OnSwap(&A[j], &A[j+1]);
			}
		}
	}
}

void CImageProcessingDoc::OnSwap(double *a, double *b)
{
	double temp;
	temp = *a;
	*a = *b;
	*b = temp;
}

void CImageProcessingDoc::OnMeanSub()
{
	int i, j,n, m, M = 3, index = 0, k;
	double *Mask, Value, Sum = 0.0;

	Mask = new double [M*M];

	m_Re_height = (m_height + 1) / M;
	m_Re_width = (m_width + 1) / M;
	m_Re_size = m_Re_height * m_Re_width;

	m_OutputImage = new unsigned char [m_Re_size];
	
	m_tempImage = Image2DMem(m_height + 1, m_width + 1);


	for(i=0 ; i<m_height ; i++){
		for(j=0 ; j<m_width ; j++){
			m_tempImage[i][j] = (double)m_InputImage[i*m_width + j];
		}
	}

	for(i=0 ; i<m_height-1 ; i=i+M){
		for(j=0 ; j<m_width-1 ; j=j+M){
			for(n=0 ; n<M ; n++){
				for(m=0 ; m<M ; m++){
					Mask[n*M + m] = m_tempImage[i+n][j+m];
				}
			}
						
			for(k=0 ; k<M*M ; k++)
				Sum = Sum + Mask[k];
			
			Value = (Sum / (M*M));
			m_OutputImage[index] = (unsigned char)Value;
			index++;
			Sum = 0.0;
		}
	}
}



void CImageProcessingDoc::OnTranslation()
{
	int i,j;
	int h_pos = 30, w_pos = 130; // ̵ ǥ
	double **tempArray;

	m_Re_height = m_height;
	m_Re_width = m_width;
	m_Re_size = m_Re_height * m_Re_width;

	m_OutputImage = new unsigned char [m_Re_size];

	m_tempImage = Image2DMem(m_height, m_width);
	tempArray = Image2DMem(m_Re_height, m_Re_width);

	for(i=0 ; i<m_height ; i++){
		for(j=0 ; j<m_width ; j++){
			m_tempImage[i][j] = (double)m_InputImage[i*m_width + j];
		}
	}

	for(i=0 ; i<m_height - h_pos ; i++){
		for(j=0 ; j<m_width - w_pos ; j++){
				tempArray[i + h_pos][j + w_pos] = m_tempImage[i][j];
				// Է  h_pos, w_pos ŭ ̵
		}
	}

	for(i=0 ; i<m_Re_height ; i++){
		for(j=0 ; j<m_Re_width ; j++){
			m_OutputImage[i*m_Re_width + j] = (unsigned char)tempArray[i][j];
		}
	}
	delete [] m_tempImage;
	delete [] tempArray;
}

void CImageProcessingDoc::OnMirrorHor()
{
	int i,j;

	m_Re_height = m_height;
	m_Re_width = m_width;
	m_Re_size = m_Re_height * m_Re_width;

	m_OutputImage = new unsigned char [m_Re_size];

	for(i=0 ; i<m_height ; i++){
		for(j=0 ; j<m_width ; j++){
			m_OutputImage[i*m_width + m_width - j - 1] = m_InputImage[i*m_width + j];
			// Է¿ 迭    迭  ڸ 
		}
	}
}

void CImageProcessingDoc::OnMirrorVer()
{
	int i,j;

	m_Re_height = m_height;
	m_Re_width = m_width;
	m_Re_size = m_Re_height * m_Re_width;

	m_OutputImage = new unsigned char [m_Re_size];

	for(i=0 ; i<m_height ; i++){
		for(j=0 ; j<m_width ; j++){
			m_OutputImage[(m_height - i -1)*m_width + j] = m_InputImage[i*m_width + j];
			// Է      迭  ڸ 
		}
	}
}

void CImageProcessingDoc::OnRotation()
{
	int i, j, CenterH, CenterW, newH, newW, Hy, degree = 45; // degree = ȸ 
	int change_CenterH, change_CenterW;
	double Radian, PI, **tempArray, Value;
	
	PI=3.14159265358979; // ȸ  PI 
	Radian = (double)degree*PI / 180.0; // degree  radian 

	m_Re_width = m_height*cos(PI/2-Radian)+m_width*cos(Radian); // ȸ  
	m_Re_height = m_height*cos(Radian)+m_width*cos(PI/2-Radian); // ȸ  ʺ
	m_Re_size = m_Re_height * m_Re_width;
	Hy=m_Re_height-1;

	m_OutputImage = new unsigned char [m_Re_size];

	CenterH = m_Re_height / 2; // ȸ  ߽ ǥ
	CenterW = m_Re_width / 2; // ȸ  ߽ ǥ


    change_CenterH = CenterH-m_height/2; //ȸ   ũ  Է  ߽ǥ ȯ   
	change_CenterW = CenterW-m_width/2; //ȸ  ʺ ũ  Է  ߽ǥ ȯ   


	m_tempImage = Image2DMem(m_height, m_width);
	tempArray = Image2DMem(m_Re_height, m_Re_width);

	for(i=0 ; i<m_width ; i++){
		for(j=0 ; j<m_height ; j++){
			m_tempImage[i][j] = (double)m_InputImage[i*m_width + j];
		}
	}

	for(i=0 ; i<m_Re_width ; i++){
		for(j=0 ; j<m_Re_height ; j++){
			// ȸ ȯ  ̿Ͽ ȸϰ  ǥ 
			newW = (int)((i-CenterW)*cos(Radian) + ((Hy-j)-CenterH)*sin(Radian)) +CenterW;
			newH = (int)(-(i-CenterW)*sin(Radian) + ((Hy-j)-CenterH)*cos(Radian)) + CenterH;

			newW-=change_CenterW;
			newH-=change_CenterH;


			if(newH < 0 || newH >= m_height){
				// ȸ ǥ    迭 Ѿ 
				Value = 0;
			}
			else if(newW < 0 || newW >= m_width){
				// ȸ ǥ    迭 Ѿ 
				Value = 0;
			}
			else{
				Value = m_tempImage[newW][newH];
			}
			tempArray[i][Hy-j] = Value;
		}
	}

	for(i=0 ; i<m_Re_width ; i++){
		for(j=0 ; j<m_Re_height ; j++){
			m_OutputImage[i*m_Re_width + j] = (unsigned char)tempArray[i][j];
		}
	}

	delete [] m_tempImage;
	delete [] tempArray;
}
