// ImageProcessingDoc.h : interface of the CImageProcessingDoc class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_IMAGEPROCESSINGDOC_H__F26059E6_6E2D_4777_B04D_CB440F4348A1__INCLUDED_)
#define AFX_IMAGEPROCESSINGDOC_H__F26059E6_6E2D_4777_B04D_CB440F4348A1__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000


struct Complex{
	double Re;
	double Im;
};

class CImageProcessingDoc : public CDocument
{
protected: // create from serialization only
	CImageProcessingDoc();
	DECLARE_DYNCREATE(CImageProcessingDoc)

// Attributes
public:

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CImageProcessingDoc)
	public:
	virtual BOOL OnNewDocument();
	virtual void Serialize(CArchive& ar);
	virtual BOOL OnOpenDocument(LPCTSTR lpszPathName);
	virtual BOOL OnSaveDocument(LPCTSTR lpszPathName);
	//}}AFX_VIRTUAL

// Implementation
public:
	double** OnMaskProcessDouble(double **Target, double Mask[3][3]);
	void OnHpfFrequency();
	void OnLpfFrequency();
	void OnIfft1d(Complex *X, int N, int Log2N);
	void OnIfft2d();
	int OnReverseBitOrder(int index, int Log2N);
	void OnButterfly(Complex *X, int N, int Log2N, int mode);
	void OnShuffle(Complex *X, int N, int Log2N);
	void OnFft1d(Complex *X, int N, int Log2N);
	void OnFft2d();
	void OnMinFilter();
	void OnMaxFilter();
	void OnMedianFilter();
	void OnMeanFilter();
	void OnHighPassFilter();
	void OnLowPassFilter();
	void OnGrayDilation();
	void OnGrayErosion();
	void OnBinaryDilation();
	void OnBinaryErosion();
	void OnFrameComb();
	void OnFrameXor();
	void OnFrameOr();
	void OnFrameAnd();
	void OnFrameDiv();
	void OnFrameMul();
	void OnFrameSub();
	void OnFrameSumB();
	void OnFrameSum();
	void OnRotation();
	void OnMirrorVer();
	void OnMirrorHor();
	void OnTranslation();
	void OnMeanSub();
	void OnSwap(double *a, double *b);
	void OnBubleSort(double *A, int MAX);
	void OnMedianSub();
	void OnBilinear();
	void OnNearest();
	void OnLaplacian();
	double DoubleABS(double X);
	void OnHomogenOperator();
	void OnDiffOperatorVer();
	void OnDiffOperatorHor();
	void OnLpfSharp();
	double** m_tempImage;
	void OnHpfSharp();
	void OnSharpening();
	void OnGaussianFilter();
	double** OnMaskProcess(unsigned char* Target, double Mask[3][3]);
	void OnBlurr();
	double** OnScale(double **Target, int height, int width);
	double** Image2DMem(int , int);
	void OnEmbossing();
	void OnEndInSearch();
	void OnHistoSpec();
	void OnHistoStretch();
	void OnHistoEqual();
	double m_HIST[256];
	double m_Sum_Of_HIST[256];
	unsigned char m_Scale_HIST[256];
	void OnHistogram();
	void OnXorOperate();
	void OnOrOperate();
	void OnAndOperate();
	void OnStressTransform();
	void OnGammaCorrection();
	void OnBinarization();
	void OnNegaTransform();
	void OnDivConstant();
	void OnMulConstant();
	void OnSubConstant();
	void OnSumConstant();
	void OnQuantization();
	void OnUpSampling();
	Complex **m_FFT, **m_IFFT;
	int m_Re_size;
	int m_Re_height;
	int m_Re_width;
	unsigned char* m_OutputImage;
	void OnDownSampling();
	int m_width;
	int m_height;
	int m_size;
	unsigned char* m_InputImage;
	virtual ~CImageProcessingDoc();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generated message map functions
protected:
	//{{AFX_MSG(CImageProcessingDoc)
		// NOTE - the ClassWizard will add and remove member functions here.
		//    DO NOT EDIT what you see in these blocks of generated code !
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_IMAGEPROCESSINGDOC_H__F26059E6_6E2D_4777_B04D_CB440F4348A1__INCLUDED_)
