// WaveletTransformDoc.h : interface of the CWaveletTransformDoc class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_WAVELETTRANSFORMDOC_H__FA6BF12B_B2FD_4C24_8DDF_C6AA8F0A4C57__INCLUDED_)
#define AFX_WAVELETTRANSFORMDOC_H__FA6BF12B_B2FD_4C24_8DDF_C6AA8F0A4C57__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000


#include "WaveletTransformDlg.h" //  

class CWaveletTransformDoc : public CDocument
{
protected: // create from serialization only
	CWaveletTransformDoc();
	DECLARE_DYNCREATE(CWaveletTransformDoc)

// Attributes
public:


// Operations
public:
	CWaveletTransformDlg *pDlg;

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CWaveletTransformDoc)
	public:
	virtual BOOL OnNewDocument();
	virtual void Serialize(CArchive& ar);
	virtual BOOL OnOpenDocument(LPCTSTR lpszPathName);
	//}}AFX_VIRTUAL

// Implementation
public:
	double *m_Recon;
	void OnSNR();
	double* OnUpSampling(double* m_Target, int size);
	void OnWaveletDecode();
	double *m_FilterH0, *m_FilterH1, *m_FilterG0, *m_FilterG1;
	int m_FilterTap;
	double** OnScale(double** m_Target, int height, int width);
	double* OnConvolution(double* m_Target, double* m_Filter, int size, int  mode);
	double* OnDownSampling(double* m_Target, int size);
	void OnFilterGen(double* m_H0, double* m_H1, double* m_G0, double* m_G1);
	void OnFilterTapGen();
	double** OnMem2DAllocDouble(int height, int width);
	unsigned char ** OnMem2DAllocUnsigned(int height, int width);
	double **m_tempInput, **m_tempOutput;
	void OnWaveletEncode();
	int m_Level;
	unsigned char *m_InputImage, *m_OutputImage, **m_ArrangeImage;
	int m_Size, m_Width, m_Height;
	void OnWaveletTransform();
	virtual ~CWaveletTransformDoc();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generated message map functions
protected:
	//{{AFX_MSG(CWaveletTransformDoc)
		// NOTE - the ClassWizard will add and remove member functions here.
		//    DO NOT EDIT what you see in these blocks of generated code !
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_WAVELETTRANSFORMDOC_H__FA6BF12B_B2FD_4C24_8DDF_C6AA8F0A4C57__INCLUDED_)
